/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   main.cpp                                           :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: bchanot <bchanot@42.fr>                    +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2025/07/17 15:10:40 by bchanot           #+#    #+#             */
/*   Updated: 2025/12/18 14:23:31 by bchanot          ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include "ClapTrap.hpp"

#include <iostream>
#include <limits>

int main( void ) {
		ClapTrap	clap = ClapTrap("Clap");
	ClapTrap	trap = ClapTrap("Trap");

	clap.attack("Trap");
	trap.beRepaired(2);
	trap.takeDamage(12);

	// Can't attack because he is dead
	trap.attack("Clap");
	clap.beRepaired(std::numeric_limits<short unsigned int>::max());
	clap.takeDamage(100);
	clap.takeDamage(std::numeric_limits<short unsigned int>::max());
	clap = ClapTrap("Clap");
	for (int i = 0; i < 100; i++)
		clap.attack("Bidule");
	trap = ClapTrap(clap);
	trap.takeDamage(100);
	clap = trap;
	trap.takeDamage(100);
	return (0);
}
